#include "posix_sockets.h"

//int Local_Port;
//char *Port;
//char *Remote_IP;
//int IS_Server;
//int Send_OK;



static void *get_in_addr(struct sockaddr *sa);
static void get_in_addr_string(int sockfd, struct sockaddr *addr);
static void sigchld_handler(int s);
static void Process_Recv(char *buf);
static void Process_Send(char *buf);
//static void *Next_Number(void *buf);



static void sigchld_handler(int s){
    while(waitpid(-1, NULL, WNOHANG) > 0);
}

static void *get_in_addr(struct sockaddr *sa){
    if (sa->sa_family == AF_INET) {
        return &(((struct sockaddr_in*)sa)->sin_addr);
    }

    return &(((struct sockaddr_in6*)sa)->sin6_addr);
}

static void get_in_addr_string(int sockfd, struct sockaddr *addr){
    //static int saved_remote = 0;
    //struct hostent *temp_hostent;
    //socklen_t addrlen = sizeof(struct sockaddr);

    if(!saved_remote){
      if(IS_Server){
           Remote_IP = (char *)malloc(INET6_ADDRSTRLEN + 1);
           (void)memset(Remote_IP, '\0', INET6_ADDRSTRLEN + 1);
           inet_ntop(addr->sa_family, get_in_addr(addr), Remote_IP, INET6_ADDRSTRLEN );
       }else{
           inet_ntop(addr->sa_family, get_in_addr(addr), Remote_IP, strlen(Remote_IP) );
       }
       saved_remote = 1;
       //Send_OK = 1;
    }

}

void *Net_Recv(void *data){
	//my_turn = 0;
    int sockfd, new_fd;  // listen on sock_fd, new connection on new_fd
    struct addrinfo hints, *servinfo, *p;
    struct sockaddr_storage their_addr; // connector's address information
    socklen_t sin_size;
    struct sigaction sa;
    int yes=1;

    //char s[INET6_ADDRSTRLEN];

    int rv;
    unsigned int bytes_recv;
    char buf[1024];

    (void)memset(buf, '\0', 1024);
    memset(&hints, 0, sizeof hints);
    hints.ai_family = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags = AI_PASSIVE; // use my IP

    if ((rv = getaddrinfo(NULL, Port, &hints, &servinfo)) != 0) {
        fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(rv));
        exit(1);
    }

    // loop through all the results and bind to the first we can
    for(p = servinfo; p != NULL; p = p->ai_next) {
        if ((sockfd = socket(p->ai_family, p->ai_socktype,
                p->ai_protocol)) == -1) {
            perror("server: socket");
            continue;
        }

        if (setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, &yes,
                sizeof(int)) == -1) {
            perror("setsockopt");
            exit(1);
        }

        if (bind(sockfd, p->ai_addr, p->ai_addrlen) == -1) {
            close(sockfd);
            perror("server: bind");
            continue;
        }

        break;
    }

    if (p == NULL)  {
        fprintf(stderr, "server: failed to bind\n");
        exit(1);
    }

    freeaddrinfo(servinfo); // all done with this structure

    if (listen(sockfd, 10) == -1) {
        perror("listen");
        exit(1);
    }

    sa.sa_handler = sigchld_handler; // reap all dead processes
    sigemptyset(&sa.sa_mask);
    sa.sa_flags = SA_RESTART;
    if (sigaction(SIGCHLD, &sa, NULL) == -1) {
        perror("sigaction");
        exit(1);
    }

    printf("server: waiting for connection...\n");

//    while(1) {  // main accept() loop

        sin_size = sizeof their_addr;

        if( (new_fd = accept(sockfd, (struct sockaddr *)&their_addr, &sin_size)) == -1){
		fprintf(stderr, "accept(): %s\n", gai_strerror(errno));
                exit(1);
	}

//        if (new_fd == -1) {
//            perror("accept");
//            continue;
//        }

        //inet_ntop(their_addr.ss_family,
        //    get_in_addr((struct sockaddr *)&their_addr),
        //    Remote_IP, INET6_ADDRSTRLEN);

        get_in_addr_string(new_fd, (struct sockaddr *)&their_addr);
        printf("server: got connection from %s\n", Remote_IP);
		//!saved
//        if (!fork()) { // this is the child process

            close(sockfd); // child doesn't need the listener
	//no longer listening for new connects at this pnt


	if(!IS_Server){
		(void)memset(buf, '\0', 1024);
		if( (bytes_recv = recv(new_fd, buf, 1023, 0)) == -1){
			perror("recv");
			fprintf(stderr, "recv(): %s\n", gai_strerror(errno));
			exit(1);
		}
		if(bytes_recv == 0){
			printf("server: remote client closed connection!\n");
			exit(1);
		}
		printf("recieved %u bytes\n", bytes_recv);
		//printf("message: %s\n", buf);
		my_team_color = atoi((const char *)buf);
		printf("MY_TEAM_COLOR: %d\n", my_team_color);
		//Send_OK = 1;
		//client goes first
		my_turn = 1;
	}

    while(1) {
            //if (send(new_fd, "Hello, world!", 13, 0) == -1)
            (void)memset(buf, '\0', 1024);
            if( (bytes_recv = recv(new_fd, buf, 1023, 0)) == -1){
                perror("recv");
                fprintf(stderr, "recv(): %s\n", gai_strerror(errno));
                exit(1);
            }
            if(bytes_recv == 0){
                printf("server: remote client closed connection!\n");
                exit(1);
            }
            printf("recieved %u bytes\n", bytes_recv);
            //printf("message: %s\n", buf);

            //
	    Process_Recv(buf);
            //close(new_fd);
            //exit(0);
        //}
        //close(new_fd);  // parent doesn't need this
    }
        close(new_fd);
	pthread_exit(NULL);
}


void *Net_Send(void *data){
	//my_turn = 0;
    int sockfd;
    //char buf[MAXDATASIZE];
    struct addrinfo hints, *servinfo, *p;
    int rv;
    unsigned int bytes_sent;
    char s[INET6_ADDRSTRLEN];
    char buf[1024];
    (void)memset(buf, '\0', 1024);

    //if (argc != 2) {
    //    fprintf(stderr,"usage: client hostname\n");
    //    exit(1);
    //}

    if(IS_Server){
        while(!saved_remote){
            sleep(1);
        }
		sleep(1);
    }
    memset(&hints, 0, sizeof hints);
    hints.ai_family = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;

    if ((rv = getaddrinfo(Remote_IP, Port, &hints, &servinfo)) != 0) {
        fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(rv));
        exit(1);
    }

    // loop through all the results and connect to the first we can
    for(p = servinfo; p != NULL; p = p->ai_next) {
        if ((sockfd = socket(p->ai_family, p->ai_socktype,
                p->ai_protocol)) == -1) {
            perror("client: socket");
            continue;
        }

        if (connect(sockfd, p->ai_addr, p->ai_addrlen) == -1) {
            close(sockfd);
            perror("client: connect");
            continue;
        }

        break;
    }

    if (p == NULL) {
        fprintf(stderr, "client: failed to connect\n");
        exit(2);
    }

    inet_ntop(p->ai_family, get_in_addr((struct sockaddr *)p->ai_addr),
            s, sizeof s);
    printf("client: connecting to %s\n", s);

    freeaddrinfo(servinfo); // all done with this structure

    //while(!Send_OK){
    //    sleep(1);
    //}

    ///server generates and sends random team color
    if(IS_Server){
		(void)memset(buf, '\0', 1024);
		int random1 = 1;
		int random2 = 1;
		while(random1 == random2){
			for(random2=0; random2<15; random2++){
				srand ( time(NULL) );
				random1 = rand() % 100 + 1;
			}
			sleep(1);
			for(random1=0; random1<15; random1++){
				srand ( time(NULL) );
				random2 = rand() % 100 + 1;
			}
		}

		printf("rand1: %d rand2: %d\n", random1, random2);

		if(random1 > random2){
			my_team_color = 0;
			(void)sprintf(buf, "%d", 1);
		}else{
			my_team_color = 1;
			(void)sprintf(buf, "%d", 0);
		}
        if( (bytes_sent = send(sockfd, buf, 1023, 0)) == -1){
            perror("send");
            fprintf(stderr, "send(): %s\n", gai_strerror(errno));
            exit(1);
        }
        printf("client: sent %u bytes\n", bytes_sent);
		//my_turn = 0;
        //printf("client: sent '%s'\n",buf);
    }

    //if(IS_Server){
		//while(my_turn == 0)
		//	sleep(1);
     //	Send_OK = 0;
    //	while(!Send_OK){
    //    	sleep(1);
    //	}
    //}

    while(1){
        (void)memset(buf, '\0', 1024);
	//sleep(1);
        //printf("\nEnter Message:");
        //if( fgets(buf, 1023, stdin) == NULL ){
        //    printf("fgets error!\n");
        //    exit(1);
        //}

//    while(1){	
        //if ((numbytes = recv(sockfd, buf, MAXDATASIZE-1, 0)) == -1) {

	Process_Send(buf);

        if( (bytes_sent = send(sockfd, buf, 1023, 0)) == -1){
            perror("send");
            fprintf(stderr, "send(): %s\n", gai_strerror(errno));
            exit(1);
        }
        printf("client: sent %u bytes\n", bytes_sent);
        //printf("client: sent '%s'\n",buf);
	//sleep(1);
    }
    //buf[numbytes] = '\0';

    //printf("client: received '%s'\n",buf);

    close(sockfd);

	pthread_exit(NULL);
}


static void Process_Send(char *buf){
	while(!Send_OK)
		sleep(1);
	int pcount;
	char tmp[25];
	(void)memset(tmp, '\0', 25);

	(void)sprintf(tmp, "%d %d %d %d ", check, op_check, checkmate, op_checkmate);
	(void)strcpy(buf, (const char *)tmp);
	(void)memset(tmp, '\0', 25);

	for(pcount=0; pcount<16; pcount++){
		(void)sprintf(tmp, "%d ", my_pieces[pcount].alive);
		(void)strcat(buf, (const char *)tmp);
		(void)memset(tmp, '\0', 25);
		(void)sprintf(tmp, "%d ", my_pieces[pcount].type);
		(void)strcat(buf, (const char *)tmp);
		(void)memset(tmp, '\0', 25);
		(void)sprintf(tmp, "%d ", my_pieces[pcount].position.x);
		(void)strcat(buf, (const char *)tmp);
		(void)memset(tmp, '\0', 25);
		(void)sprintf(tmp, "%d ", my_pieces[pcount].position.y);
		(void)strcat(buf, (const char *)tmp);
		(void)memset(tmp, '\0', 25);
		(void)sprintf(tmp, "%d ", my_pieces[pcount].first_turn);
		(void)strcat(buf, (const char *)tmp);
		(void)memset(tmp, '\0', 25);
		(void)sprintf(tmp, "%d ", my_pieces[pcount].color);
		(void)strcat(buf, (const char *)tmp);
		(void)memset(tmp, '\0', 25);
		//(void)sprintf(tmp, "%d ", my_pieces[pcount].alive);
	}
	for(pcount=0; pcount<16; pcount++){
		(void)sprintf(tmp, "%d ", oponent_pieces[pcount].alive); //printf("alive: %s\n", tmp);
		(void)strcat(buf, (const char *)tmp);
		(void)memset(tmp, '\0', 25);
		(void)sprintf(tmp, "%d ", oponent_pieces[pcount].type); //printf("type: %s\n", tmp);
		(void)strcat(buf, (const char *)tmp);
		(void)memset(tmp, '\0', 25);
		(void)sprintf(tmp, "%d ", oponent_pieces[pcount].position.x); //printf("position.x: %s\n", tmp);
		(void)strcat(buf, (const char *)tmp);
		(void)memset(tmp, '\0', 25);
		(void)sprintf(tmp, "%d ", oponent_pieces[pcount].position.y); //printf("position.y: %s\n", tmp);
		(void)strcat(buf, (const char *)tmp);
		(void)memset(tmp, '\0', 25);
		(void)sprintf(tmp, "%d ", oponent_pieces[pcount].first_turn); //printf("first_turn: %s\n", tmp);
		(void)strcat(buf, (const char *)tmp);
		(void)memset(tmp, '\0', 25);
		(void)sprintf(tmp, "%d ", oponent_pieces[pcount].color);
		(void)strcat(buf, (const char *)tmp);
		(void)memset(tmp, '\0', 25);
	}
	//printf("SEND: %s\n", buf);
	//sleep(1);
	Send_OK = 0;
}

static void Process_Recv(char *buf){
	int pcount;
	//int pos = 0;
	//my_turn = atoi((const char *)buf);
	//buf = (char *)Next_Number((void *)buf);	
	//void *ptr = buf;
        char *token;
        //char *line;
        char *search = " ";
	//printf("RECV: %s\n", buf);
	////0 nobody in check  1 i'm in check  2 opponent in check  3 both in check
	token = strtok(buf, search);

	op_check = atoi((const char *)token);
	token = strtok(NULL, search);

	check = atoi((const char *)token);
	token = strtok(NULL, search);

	op_checkmate = atoi((const char *)token);
	token = strtok(NULL, search);

	checkmate = atoi((const char *)token);
	token = strtok(NULL, search);

	for(pcount=0; pcount<16; pcount++){
		oponent_pieces[pcount].alive      = atoi((const char *)token);
		token = strtok(NULL, search);
		//ptr = (char *)Next_Number((void *)ptr);
		oponent_pieces[pcount].type       = atoi((const char *)token);
		token = strtok(NULL, search);
		//ptr = (char *)Next_Number((void *)ptr);
		oponent_pieces[pcount].position.x = atoi((const char *)token);
		token = strtok(NULL, search);
		//ptr = (char *)Next_Number((void *)ptr);
		oponent_pieces[pcount].position.y = atoi((const char *)token);
		token = strtok(NULL, search);
		//ptr = (char *)Next_Number((void *)ptr);
		oponent_pieces[pcount].first_turn = atoi((const char *)token);
		token = strtok(NULL, search);
		//ptr = (char *)Next_Number((void *)ptr);
		oponent_pieces[pcount].color = atoi((const char *)token);
		token = strtok(NULL, search);
	}
	for(pcount=0; pcount<16; pcount++){
		my_pieces[pcount].alive           = atoi((const char *)token);
		token = strtok(NULL, search);//ptr = (char *)Next_Number((void *)ptr);
		my_pieces[pcount].type            = atoi((const char *)token);
		token = strtok(NULL, search);//ptr = (char *)Next_Number((void *)ptr);
		my_pieces[pcount].position.x      = atoi((const char *)token);
		token = strtok(NULL, search);//ptr = (char *)Next_Number((void *)ptr);
		my_pieces[pcount].position.y      = atoi((const char *)token);
		token = strtok(NULL, search);//ptr = (char *)Next_Number((void *)ptr);
		my_pieces[pcount].first_turn      = atoi((const char *)token);
		token = strtok(NULL, search);//ptr = (char *)Next_Number((void *)ptr);
		my_pieces[pcount].color            = atoi((const char *)token);
		token = strtok(NULL, search);
/*
		printf("%d: alive %d\n", pcount, my_pieces[pcount].alive);
		printf("%d: type %d\n", pcount, my_pieces[pcount].type);
		printf("%d: position.x %d\n", pcount, my_pieces[pcount].position.x);
		printf("%d: position.y %d\n", pcount, my_pieces[pcount].position.y);
		printf("%d: first_turn %d\n", pcount, my_pieces[pcount].first_turn);
*/
	}


//printf("%s\n", buf);

	//sleep(1);
	//Send_OK = 1;
	my_turn = 1;
}

/*
static void *Next_Number(void *buf){
	int count=0;
	char *ptr = buf;
	while(ptr[count] != ' ' && ptr[count] != '\0')
		count++;

	return (void *)&ptr[count+1];
}
*/